﻿Friend Class ConfigurationsViewModel
	Private ReadOnly FormFactory As IFormFactory
	Private ConfigurationsForm As IConfigurationsForm = Nothing
	Private ReadOnly OldFilePath As String
	Private _NewFilePath As String

	Public ReadOnly Property NewFilePath As String
		Get
			Return _NewFilePath
		End Get
	End Property

	Public Sub New(FormFactory As IFormFactory, CurrentFilePath As String)
		Me.FormFactory = FormFactory
		Me.OldFilePath = CurrentFilePath
	End Sub

	Public Sub ShowConfigurations()
		CreateNewConfigurationsForm()
		WireEvents
		ShowConfigurationsForm
		CutEventWires
	End Sub

	Private Sub CreateNewConfigurationsForm()
		Me.ConfigurationsForm = FormFactory.CreateNewConfigurationsForm
	End Sub

	Private Sub WireEvents()
		AddHandler ConfigurationsForm.ShowFileSelection, AddressOf SelectNewFilePath
	End Sub

	Private Sub ShowConfigurationsForm()
		ConfigurationsForm.ShowFilePath(OldFilePath)
		ConfigurationsForm.Show()
	End Sub

	Private Sub CutEventWires()
		RemoveHandler ConfigurationsForm.ShowFileSelection, AddressOf SelectNewFilePath
	End Sub

	Private Sub SelectNewFilePath(sender As Object, e As EventArgs)
		ShowFileDialog()
		ShowNewFilePath()
	End Sub

	Private Sub ShowFileDialog()
		Using Sfd As New SaveFileDialog
			Sfd.InitialDirectory = IO.Path.GetDirectoryName(Application.ExecutablePath)
			Sfd.Filter = "Text-Dateien|*.txt"
			Sfd.ShowDialog()
			_NewFilePath = IO.Path.GetFileName(Sfd.FileName)
		End Using
	End Sub

	Private Sub ShowNewFilePath()
		ConfigurationsForm.ShowFilePath(_NewFilePath)
	End Sub

End Class